#if defined(__linux__)
#if defined(__arm__)

/*
 * Use Linux system call.
 */

#define SYS_exit   1
#define SYS_read   3
#define SYS_write  4
#define SYS_open   5
#define SYS_close  6
#define SYS_ioctl 54

	.section .text

	.globl	___exit
	.type	___exit, %function
___exit:
	push	{ r4, r5, r6, r7 }
	mov	r7, #SYS_exit
	swi	0
	pop	{ r4, r5, r6, r7 }
	mov	pc, lr

	.globl	__read
	.type	__read, %function
__read:
	push	{ r4, r5, r6, r7 }
	mov	r7, #SYS_read
	swi	0
	pop	{ r4, r5, r6, r7 }
	mov	pc, lr

	.globl	__write
	.type	__write, %function
__write:
	push	{ r4, r5, r6, r7 }
	mov	r7, #SYS_write
	swi	0
	pop	{ r4, r5, r6, r7 }
	mov	pc, lr

	.globl	__open
	.type	__open, %function
__open:
	push	{ r4, r5, r6, r7 }
	mov	r7, #SYS_open
	swi	0
	pop	{ r4, r5, r6, r7 }
	mov	pc, lr

	.globl	__close
	.type	__close, %function
__close:
	push	{ r4, r5, r6, r7 }
	mov	r7, #SYS_close
	swi	0
	pop	{ r4, r5, r6, r7 }
	mov	pc, lr

	.globl	__ioctl
	.type	__ioctl, %function
__ioctl:
	push	{ r4, r5, r6, r7 }
	mov	r7, #SYS_ioctl
	swi	0
	pop	{ r4, r5, r6, r7 }
	mov	pc, lr
#endif
#endif
